#include "Vram.h"
#include "Chars.h"

extern byte[] MonoChars, ColorChars, Ascii, FenceChars;
extern byte[] LineChars;


void InitPatterns()
{
    WriteMonoPattern(
        PatternRam + Char_Ascii * CharHeight, 
        Ascii, 7, Char_Logo - Char_Ascii
    );
    WriteMonoPattern(
        PatternRam + Char_Logo * CharHeight, 
        MonoChars + (Char_Logo - Char_Logo) * CharHeight, 5, 16
    );
    WriteMonoPattern(
        PatternRam + Char_Block * CharHeight, 
        MonoChars + (Char_Block - Char_Logo) * CharHeight, 1, 4
    );
    WriteMonoPattern(
        PatternRam + Char_Item * CharHeight, 
        MonoChars + (Char_Item - Char_Logo) * CharHeight, 6, 4
    );
    WriteMonoPattern(
        PatternRam + Char_Line_Normal * CharHeight, 
        LineChars, 7, 8
    );
    WriteMonoPattern(
        PatternRam + Char_Line_Red * CharHeight, 
        LineChars, 2, 8
    );
    WriteColorPattern(
        PatternRam + Char_Man * CharHeight, 
        ColorChars, Char_Fence - Char_Man
    );
    WriteMonoPattern(
        PatternRam + Char_Fence * CharHeight, 
        FenceChars, 1, 2
    );
}

void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            *pVram = c;
            ++pVram;
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
}
